Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3483)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3484)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Introduction of reversibility correction to the interpolation routines in order to 
+! guarantee mass and scalar conservation through the nest boundaries. Several errors 
+! are corrected and pmci_ensure_nest_mass_conservation is permanently removed. 
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -366,5 +371,5 @@
     USE pegrid,                                                                &
         ONLY:  collective_wait, comm1dx, comm1dy, comm2d, myid, myidx, myidy,  &
-               numprocs
+               numprocs, pleft, pnorth, pright, psouth, status
 
     USE pmc_child,                                                             &
@@ -417,5 +422,5 @@
     INTEGER(iwp), SAVE      ::  cpl_parent_id         !<
 !
-!-- Control parameters, will be made input parameters later
+!-- Control parameters
     CHARACTER(LEN=7), SAVE ::  nesting_datatransfer_mode = 'mixed'  !< steering
                                                          !< parameter for data-
@@ -441,6 +446,7 @@
 
 !
-!-- Child coarse data arrays
-    INTEGER(iwp), DIMENSION(5),PUBLIC           ::  coarse_bound   !<
+!-- Children's parent-grid arrays
+    INTEGER(iwp), SAVE, DIMENSION(5), PUBLIC    ::  coarse_bound        !< subdomain index bounds for children's parent-grid arrays
+    INTEGER(iwp), SAVE, DIMENSION(4), PUBLIC    ::  coarse_bound_anterp !< subdomain index bounds for anterpolation
 
     REAL(wp), SAVE                              ::  xexl           !<
@@ -492,4 +498,5 @@
     REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zw   !<
     REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zw   !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  celltmpd !<
 !
 !-- Child index arrays and log-ratio arrays for the log-law near-wall
@@ -534,5 +541,5 @@
 !
 !-- Upper bounds for k in anterpolation.
-    INTEGER(iwp), SAVE ::  kctu   !<
+    INTEGER(iwp), SAVE ::  kcto   !<
     INTEGER(iwp), SAVE ::  kctw   !<
 !
@@ -599,7 +606,6 @@
 
     TYPE(coarsegrid_def), SAVE, PUBLIC     ::  cg   !<
-
-!-  Variables for particle coupling
-
+!
+!-- Variables for particle coupling
     TYPE, PUBLIC :: childgrid_def
        INTEGER(iwp)                        ::  nx                   !<
@@ -641,8 +647,4 @@
     END INTERFACE pmci_datatrans
 
-    INTERFACE pmci_ensure_nest_mass_conservation
-       MODULE PROCEDURE pmci_ensure_nest_mass_conservation
-    END INTERFACE
-
     INTERFACE pmci_init
        MODULE PROCEDURE pmci_init
@@ -687,5 +689,4 @@
     PUBLIC pmci_child_initialize
     PUBLIC pmci_datatrans
-    PUBLIC pmci_ensure_nest_mass_conservation
     PUBLIC pmci_init
     PUBLIC pmci_modelconfiguration
@@ -891,6 +892,6 @@
        IF ( myid == 0 )  THEN
 
-          CALL pmc_recv_from_child( child_id, val,  size(val),  0, 123, ierr )
-          CALL pmc_recv_from_child( child_id, fval, size(fval), 0, 124, ierr )
+          CALL pmc_recv_from_child( child_id, val,  SIZE(val),  0, 123, ierr )
+          CALL pmc_recv_from_child( child_id, fval, SIZE(fval), 0, 124, ierr )
          
           nx_cl     = val(1)
@@ -983,5 +984,5 @@
                    mid = pmc_parent_for_child(mm)
 !
-!--                Check Only different nest level
+!--                Check only different nest levels
                    IF (m_couplers(child_id)%parent_id /= m_couplers(mid)%parent_id)  THEN
                       IF ( ( ch_xl(m) < ch_xr(mm) .OR.                         &
@@ -1000,5 +1001,4 @@
           DEALLOCATE( cl_coord_x )
           DEALLOCATE( cl_coord_y )
-
 !
 !--       Send information about operating mode (LES or RANS) to child. This will be 
@@ -1219,10 +1219,14 @@
 
     INTEGER(iwp) ::  i          !<
-    INTEGER(iwp) ::  ierr       !<
-    INTEGER(iwp) ::  icl        !<
-    INTEGER(iwp) ::  icr        !<
-    INTEGER(iwp) ::  j          !<
-    INTEGER(iwp) ::  jcn        !<
-    INTEGER(iwp) ::  jcs        !<
+    INTEGER(iwp) ::  ierr       !< 
+    INTEGER(iwp) ::  icl        !< left index limit for children's parent-grid arrays
+    INTEGER(iwp) ::  icla       !< left index limit for anterpolation
+    INTEGER(iwp) ::  icr        !< left index limit for children's parent-grid arrays
+    INTEGER(iwp) ::  icra       !< right index limit for anterpolation
+    INTEGER(iwp) ::  j          !< 
+    INTEGER(iwp) ::  jcn        !< north index limit for children's parent-grid arrays
+    INTEGER(iwp) ::  jcna       !< north index limit for anterpolation
+    INTEGER(iwp) ::  jcs        !< sout index limit for children's parent-grid arrays
+    INTEGER(iwp) ::  jcsa       !< south index limit for anterpolation
     INTEGER(iwp) ::  n          !< running index for number of chemical species
 
@@ -1374,12 +1378,10 @@
 !--    Get coarse grid coordinates and values of the z-direction from the parent
        IF ( myid == 0)  THEN
-
           CALL pmc_recv_from_parent( cg%coord_x, cg%nx+1+2*nbgp, 0, 24, ierr )
           CALL pmc_recv_from_parent( cg%coord_y, cg%ny+1+2*nbgp, 0, 25, ierr )
-          CALL pmc_recv_from_parent( cg%dzu, cg%nz + 1, 0, 26, ierr )
-          CALL pmc_recv_from_parent( cg%dzw, cg%nz + 1, 0, 27, ierr )
-          CALL pmc_recv_from_parent( cg%zu, cg%nz + 2, 0, 28, ierr )
-          CALL pmc_recv_from_parent( cg%zw, cg%nz + 2, 0, 29, ierr )
-
+          CALL pmc_recv_from_parent( cg%dzu, cg%nz+1, 0, 26, ierr )
+          CALL pmc_recv_from_parent( cg%dzw, cg%nz+1, 0, 27, ierr )
+          CALL pmc_recv_from_parent( cg%zu, cg%nz+2, 0, 28, ierr )
+          CALL pmc_recv_from_parent( cg%zw, cg%nz+2, 0, 29, ierr )
        ENDIF
 !
@@ -1392,5 +1394,4 @@
        CALL MPI_BCAST( cg%zw, cg%nz+2,  MPI_REAL, 0, comm2d, ierr )
        CALL MPI_BCAST( rans_mode_parent, 1, MPI_LOGICAL, 0, comm2d, ierr )
-  
 !
 !--    Find the index bounds for the nest domain in the coarse-grid index space
@@ -1441,8 +1442,9 @@
 !--    Precompute the index arrays and relaxation functions for the
 !--    anterpolation
-       IF ( TRIM( nesting_mode ) == 'two-way' .OR.                             &
-                  nesting_mode == 'vertical' )  THEN
-          CALL pmci_init_anterp_tophat
-       ENDIF
+!
+!--    Note that the anterpolation index bounds are needed also in case
+!--    of one-way coupling because of the reversibility correction
+!--    included in the interpolation algorithms.
+       CALL pmci_init_anterp_tophat
 !
 !--    Finally, compute the total area of the top-boundary face of the domain.
@@ -1463,5 +1465,8 @@
        INTEGER(iwp), DIMENSION(5,numprocs) ::  coarse_bound_all   !<
        INTEGER(iwp), DIMENSION(2)          ::  size_of_array      !<
-                                              
+                                   
+       INTEGER(iwp) :: i        !<   
+       INTEGER(iwp) :: ijaux    !< 
+       INTEGER(iwp) :: j        !< 
        REAL(wp) ::  loffset     !<
        REAL(wp) ::  noffset     !<
@@ -1536,4 +1541,64 @@
        coarse_bound(5) = myid
 !
+!--    Determine the anterpolation index limits. If at least half of the 
+!--    parent-grid cell is within the current child sub-domain, then it 
+!--    is included in the current sub-domain's anterpolation domain. 
+!--    Else the parent-grid cell is included in the neighbouring subdomain's 
+!--    anterpolation domain, or not included at all if we are at the outer 
+!--    edge of the child domain.
+       DO  i = 0, cg%nx
+          IF ( cg%coord_x(i) + 0.5_wp * cg%dx >= coord_x(nxl) )  THEN
+             icla = MAX( 0, i )
+             EXIT
+          ENDIF
+       ENDDO
+       DO  i = cg%nx, 0 , -1
+          IF ( cg%coord_x(i) + 0.5_wp * cg%dx <= coord_x(nxr+1) )  THEN
+             icra = MIN( cg%nx, i )
+             EXIT
+          ENDIF
+       ENDDO
+       DO  j = 0, cg%ny
+          IF ( cg%coord_y(j) + 0.5_wp * cg%dy >= coord_y(nys) )  THEN
+             jcsa = MAX( 0, j )
+             EXIT
+          ENDIF
+       ENDDO
+       DO  j = cg%ny, 0 , -1
+          IF ( cg%coord_y(j) + 0.5_wp * cg%dy <= coord_y(nyn+1) )  THEN
+             jcna = MIN( cg%ny, j )
+             EXIT
+          ENDIF
+       ENDDO
+!
+!--    Make sure that the indexing is contiguous 
+       IF ( nxl == 0 )  THEN
+          CALL MPI_SEND( icra, 1, MPI_INTEGER, pright, 717, comm2d, ierr )
+       ELSE IF ( nxr == nx )  THEN
+          CALL MPI_RECV( ijaux, 1, MPI_INTEGER, pleft, 717, comm2d, status, ierr )
+          icla = ijaux + 1
+       ELSE
+          CALL MPI_SEND( icra, 1, MPI_INTEGER, pright, 717, comm2d, ierr )
+          CALL MPI_RECV( ijaux, 1, MPI_INTEGER, pleft, 717, comm2d, status, ierr ) 
+          icla = ijaux + 1
+       ENDIF
+       IF ( nys == 0 )  THEN
+          CALL MPI_SEND( jcna, 1, MPI_INTEGER, pnorth, 719, comm2d, ierr )
+       ELSE IF ( nyn == ny )  THEN
+          CALL MPI_RECV( ijaux, 1, MPI_INTEGER, psouth, 719, comm2d, status, ierr )
+          jcsa = ijaux + 1
+       ELSE
+          CALL MPI_SEND( jcna, 1, MPI_INTEGER, pnorth, 719, comm2d, ierr )
+          CALL MPI_RECV( ijaux, 1, MPI_INTEGER, psouth, 719, comm2d, status, ierr ) 
+          jcsa = ijaux + 1
+       ENDIF
+
+       write(9,"('Anterpolation bounds: ',4(i3,2x))") icla, icra, jcsa, jcna
+       flush(9)
+       coarse_bound_anterp(1) = icla
+       coarse_bound_anterp(2) = icra
+       coarse_bound_anterp(3) = jcsa
+       coarse_bound_anterp(4) = jcna
+!
 !--    Note that MPI_Gather receives data from all processes in the rank order
 !--    TO_DO: refer to the line where this fact becomes important
@@ -1561,4 +1626,5 @@
        IMPLICIT NONE
 
+       INTEGER(iwp) ::  acsize  !<
        INTEGER(iwp) ::  i       !<
        INTEGER(iwp) ::  j       !<
@@ -1568,4 +1634,6 @@
        INTEGER(iwp) ::  kdzw    !<       
 
+       REAL(wp) ::  dzmin       !<
+       REAL(wp) ::  parentdzmax !<
        REAL(wp) ::  xb          !<
        REAL(wp) ::  xcsu        !<
@@ -1583,5 +1651,5 @@
        REAL(wp) ::  zfsw        !<
       
-
+       
        xb = nxl * dx
        yb = nys * dy
@@ -1658,4 +1726,20 @@
           r1zo(k) = 1.0_wp - r2zo(k)
        ENDDO
+!
+!--    Determine the maximum dimension of anterpolation cells and allocate the
+!--    work array celltmpd needed in the reversibility correction in the 
+!--    interpolation
+       dzmin = 999999.9_wp
+       DO k = 1, nzt+1
+          dzmin = MIN( dzmin, dzu(k), dzw(k) )
+       ENDDO
+       parentdzmax = 0.0_wp
+       DO k = 1, cg%nz+1
+          parentdzmax = MAX(parentdzmax , cg%dzu(k), cg%dzw(k) )
+       ENDDO
+       acsize = CEILING( cg%dx / dx ) * CEILING( cg%dy / dy ) *                 &
+            CEILING( parentdzmax / dzmin )
+       ALLOCATE( celltmpd(1:acsize) )
+!       write(9,"('acsize: ',i3,2(e12.5,2x))") acsize, dzmin, parentdzmax
       
     END SUBROUTINE pmci_init_interp_tril
@@ -3007,4 +3091,5 @@
        REAL(wp)     ::  xi       !<
        REAL(wp)     ::  eta      !<
+       REAL(wp)     ::  tolerance !<
        REAL(wp)     ::  zeta     !<
      
@@ -3027,5 +3112,5 @@
        ENDIF
 !
-!--    First determine kctu and kctw that are the coarse-grid upper bounds for
+!--    First determine kcto and kctw that are the coarse-grid upper bounds for
 !--    index k
        kk = 0
@@ -3033,5 +3118,5 @@
           kk = kk + 1
        ENDDO
-       kctu = kk - 1
+       kcto = kk - 1
 
        kk = 0
@@ -3049,13 +3134,14 @@
        ALLOCATE( jfuv(jcs:jcn) )
        ALLOCATE( jfuo(jcs:jcn) )
-       ALLOCATE( kflw(0:kctw) )
-       ALLOCATE( kflo(0:kctu) )
-       ALLOCATE( kfuw(0:kctw) )
-       ALLOCATE( kfuo(0:kctu) )
-
-       ALLOCATE( ijkfc_u(0:kctu,jcs:jcn,icl:icr) )
-       ALLOCATE( ijkfc_v(0:kctu,jcs:jcn,icl:icr) )
-       ALLOCATE( ijkfc_w(0:kctw,jcs:jcn,icl:icr) )
-       ALLOCATE( ijkfc_s(0:kctu,jcs:jcn,icl:icr) )
+       ALLOCATE( kflw(0:cg%nz+1) )
+       ALLOCATE( kflo(0:cg%nz+1) )
+       ALLOCATE( kfuw(0:cg%nz+1) )
+       ALLOCATE( kfuo(0:cg%nz+1) )
+
+       ALLOCATE( ijkfc_u(0:cg%nz+1,jcs:jcn,icl:icr) )
+       ALLOCATE( ijkfc_v(0:cg%nz+1,jcs:jcn,icl:icr) )
+       ALLOCATE( ijkfc_w(0:cg%nz+1,jcs:jcn,icl:icr) )
+       ALLOCATE( ijkfc_s(0:cg%nz+1,jcs:jcn,icl:icr) )
+
        ijkfc_u = 0
        ijkfc_v = 0
@@ -3065,20 +3151,44 @@
 !--    i-indices of u for each ii-index value
 !--    ii=icr is redundant for anterpolation
+       tolerance = 0.000001_wp * dx
        istart = nxlg
        DO  ii = icl, icr-1
+!
+!--       In case the child and parent grid lines match in x 
+!--       use only the local k,j-child-grid plane for the anterpolation, 
+!--       i.e use 2-D anterpolation. Else, use a 3-D anterpolation.
           i = istart
-          DO  WHILE ( ( coord_x(i) < cg%coord_x(ii) - 0.5_wp * cg%dx )  .AND.  &
-                      ( i < nxrg ) )
-             i  = i + 1
+          DO WHILE ( coord_x(i) < cg%coord_x(ii) - tolerance  .AND.  i < nxrg )
+             i = i + 1
           ENDDO
-          iflu(ii) = MIN( MAX( i, nxlg ), nxrg )
-          ir = i
-          DO  WHILE ( ( coord_x(ir) <= cg%coord_x(ii) + 0.5_wp * cg%dx )  .AND.&
-                      ( i < nxrg+1 ) )
-             i  = i + 1
-             ir = MIN( i, nxrg )
-          ENDDO
-          ifuu(ii) = MIN( MAX( i-1, iflu(ii) ), nxrg )
-          istart = iflu(ii)
+          IF ( ABS( coord_x(i) - cg%coord_x(ii) ) < tolerance )  THEN
+             i = istart
+             DO WHILE ( coord_x(i) < cg%coord_x(ii) .AND. i < nxrg )
+                i = i + 1
+             ENDDO
+             iflu(ii) = MIN( MAX( i, nxlg ), nxrg )
+             ifuu(ii) = iflu(ii)
+             istart   = iflu(ii)
+          ELSE
+             i = istart
+             DO  WHILE ( ( coord_x(i) < cg%coord_x(ii) - 0.5_wp * cg%dx )       &
+                  .AND.  ( i < nxrg ) )
+                i  = i + 1
+             ENDDO
+             iflu(ii) = MIN( MAX( i, nxlg ), nxrg )
+             ir = i
+             DO  WHILE ( ( coord_x(ir) <= cg%coord_x(ii) + 0.5_wp * cg%dx )     &
+                  .AND.  ( i < nxrg+1 ) )
+                i  = i + 1
+                ir = MIN( i, nxrg )
+             ENDDO
+             ifuu(ii) = MIN( MAX( i-1, iflu(ii) ), nxrg )
+             istart = iflu(ii)
+          ENDIF
+!AH
+          write(9,"('pmci_init_anterp_tophat, ii, iflu, ifuu: ', 3(i4,2x))")    &
+               ii, iflu(ii), ifuu(ii)
+          flush(9)
+
        ENDDO
        iflu(icr) = nxrg
@@ -3104,4 +3214,9 @@
           istart = iflo(ii)
        ENDDO
+!AH
+       write(9,"('pmci_init_anterp_tophat, ii, iflo, ifuo: ', 3(i4,2x))")    &
+            ii, iflo(ii), ifuo(ii)
+       flush(9)
+          
        iflo(icr) = nxrg
        ifuo(icr) = nxrg
@@ -3109,20 +3224,44 @@
 !--    j-indices of v for each jj-index value
 !--    jj=jcn is redundant for anterpolation
+       tolerance = 0.000001_wp * dy
        jstart = nysg
        DO  jj = jcs, jcn-1
+!
+!--       In case the child and parent grid lines match in y 
+!--       use only the local k,i-child-grid plane for the anterpolation, 
+!--       i.e use 2-D anterpolation. Else, use a 3-D anterpolation.
           j = jstart
-          DO  WHILE ( ( coord_y(j) < cg%coord_y(jj) - 0.5_wp * cg%dy )  .AND.  &
-                      ( j < nyng ) )
-             j  = j + 1
+          DO WHILE ( coord_y(j) < cg%coord_y(jj) - tolerance  .AND.  j < nyng )
+             j = j + 1
           ENDDO
-          jflv(jj) = MIN( MAX( j, nysg ), nyng )
-          jr = j
-          DO  WHILE ( ( coord_y(jr) <= cg%coord_y(jj) + 0.5_wp * cg%dy )  .AND.&
-                      ( j < nyng+1 ) )
-             j  = j + 1
-             jr = MIN( j, nyng )
-          ENDDO
-          jfuv(jj) = MIN( MAX( j-1, jflv(jj) ), nyng )
-          jstart = jflv(jj)
+          IF ( ABS( coord_y(j) - cg%coord_y(jj) ) < tolerance )  THEN
+             j = jstart
+             DO WHILE ( coord_y(j) < cg%coord_y(jj) .AND. j < nyng )
+                j = j + 1
+             ENDDO
+             jflv(jj) = MIN( MAX( j, nysg ), nyng )
+             jfuv(jj) = jflv(jj)
+             jstart   = jflv(jj)
+          ELSE
+             j = jstart
+             DO  WHILE ( ( coord_y(j) < cg%coord_y(jj) - 0.5_wp * cg%dy )       &
+                  .AND.  ( j < nyng ) )
+                j  = j + 1
+             ENDDO
+             jflv(jj) = MIN( MAX( j, nysg ), nyng )
+             jr = j
+             DO  WHILE ( ( coord_y(jr) <= cg%coord_y(jj) + 0.5_wp * cg%dy )     &
+                  .AND.  ( j < nyng+1 ) )
+                j  = j + 1
+                jr = MIN( j, nyng )
+             ENDDO
+             jfuv(jj) = MIN( MAX( j-1, jflv(jj) ), nyng )
+             jstart = jflv(jj)
+          ENDIF
+!AH
+          write(9,"('pmci_init_anterp_tophat, jj, jflv, jfuv: ', 3(i4,2x))")    &
+               jj, jflv(jj), jfuv(jj)
+          flush(9)
+
        ENDDO
        jflv(jcn) = nyng
@@ -3147,4 +3286,9 @@
           jfuo(jj) = MIN( MAX( j-1, jflo(jj) ), nyng )
           jstart = jflo(jj)
+!AH
+          write(9,"('pmci_init_anterp_tophat, ii, jflo, jfuo: ', 3(i4,2x))")    &
+               jj, jflo(jj), jfuo(jj)
+          flush(9)
+
        ENDDO
        jflo(jcn) = nyng
@@ -3152,18 +3296,49 @@
 !
 !--    k-indices of w for each kk-index value
+!--    Note that anterpolation index limits are needed also for the top boundary 
+!--    ghost cell level because of the reversibility correction in the interpolation.
        kstart  = 0
        kflw(0) = 0
        kfuw(0) = 0
-       DO  kk = 1, kctw
+       tolerance = 0.000001_wp * dzw(1)
+       DO kk = 1, cg%nz+1
+!
+!--       In case the child and parent grid lines match in z
+!--       use only the local j,i-child-grid plane for the anterpolation, 
+!--       i.e use 2-D anterpolation. Else, use a 3-D anterpolation.
           k = kstart
-          DO  WHILE ( ( zw(k) < cg%zu(kk) )  .AND.  ( k < nzt ) )
+          DO WHILE ( zw(k) < cg%zw(kk) - tolerance  .AND.  k < nzt+1 )
              k = k + 1
           ENDDO
-          kflw(kk) = MIN( MAX( k, 1 ), nzt + 1 )
-          DO  WHILE ( ( zw(k) <= cg%zu(kk+1) )  .AND.  ( k < nzt+1 ) )
-             k  = k + 1
-          ENDDO
-          kfuw(kk) = MIN( MAX( k-1, kflw(kk) ), nzt + 1 )
-          kstart = kflw(kk)
+          IF ( ABS( zw(k) - cg%zw(kk) ) < tolerance )  THEN
+             k = kstart
+             DO WHILE ( ( zw(k) < cg%zw(kk) )  .AND.  ( k < nzt+1 ) )
+                k = k + 1
+             ENDDO
+             kflw(kk) = MIN( MAX( k, 1 ), nzt + 1 )
+             kfuw(kk) = kflw(kk)
+             kstart   = kflw(kk)
+          ELSE
+             k = kstart
+             DO  WHILE ( ( zw(k) < cg%zu(kk) )  .AND.  ( k < nzt ) )
+                k = k + 1
+             ENDDO
+             kflw(kk) = MIN( MAX( k, 1 ), nzt + 1 )
+             IF ( kk+1 <= cg%nz+1 )  THEN
+                DO  WHILE ( ( zw(k) <= cg%zu(kk+1) )  .AND.  ( k < nzt+1 ) )
+                   k  = k + 1
+                   IF ( k > nzt + 1 ) EXIT  ! This EXIT is to prevent zu(k) from flowing over.
+                ENDDO
+                kfuw(kk) = MIN( MAX( k-1, kflw(kk) ), nzt + 1 )
+             ELSE
+                kfuw(kk) = kflw(kk)
+             ENDIF
+             kstart = kflw(kk)
+          ENDIF
+!AH
+          write(9,"('pmci_init_anterp_tophat, kk, kflw, kfuw: ', 3(i4,2x))") &
+               kk, kflw(kk), kfuw(kk)
+          flush(9)
+
        ENDDO
 !
@@ -3172,23 +3347,36 @@
        kflo(0) = 0
        kfuo(0) = 0
-       DO  kk = 1, kctu
+!
+!--    Note that anterpolation index limits are needed also for the top boundary 
+!--    ghost cell level because of the reversibility correction in the interpolation.
+!AH       DO  kk = 1, kcto+1
+       DO  kk = 1, cg%nz+1
           k = kstart
-          DO  WHILE ( ( zu(k) < cg%zw(kk-1) )  .AND.  ( k < nzt ) )
+!AH          DO  WHILE ( ( zu(k) < cg%zw(kk-1) )  .AND.  ( k < nzt ) )
+!--       Note that this is an IMPORTANT correction for the reversibility correction
+          DO  WHILE ( ( zu(k) < cg%zw(kk-1) )  .AND.  ( k <= nzt ) )
              k = k + 1
           ENDDO
           kflo(kk) = MIN( MAX( k, 1 ), nzt + 1 )
-          DO  WHILE ( ( zu(k) <= cg%zw(kk) )  .AND.  ( k < nzt+1 ) )
+!AH          DO  WHILE ( ( zu(k) <= cg%zw(kk) )  .AND.  ( k < nzt+1 ) )
+!--       Note that this is an IMPORTANT correction for the reversibility correction
+          DO  WHILE ( ( zu(k) <= cg%zw(kk) )  .AND.  ( k <= nzt+1 ) )
              k = k + 1
+             IF ( k > nzt + 1 ) EXIT  ! This EXIT is to prevent zu(k) from flowing over.
           ENDDO
           kfuo(kk) = MIN( MAX( k-1, kflo(kk) ), nzt + 1 )
           kstart = kflo(kk)
+!AH
+          write(9,"('init kflo, kfuo: ', 4(i3,2x), e12.5)") kk, kflo(kk), kfuo(kk), nzt,  cg%zw(kk)
+          flush(9)
        ENDDO
 !
-!--    Precomputation of number of fine-grid nodes inside coarse-grid ij-faces.
-!--    Note that ii, jj, and kk are coarse-grid indices. 
+!--    Precomputation of number of fine-grid nodes inside parent-grid cells.
+!--    Note that ii, jj, and kk are parent-grid indices. 
 !--    This information is needed in anterpolation.
        DO  ii = icl, icr
           DO  jj = jcs, jcn
-             DO kk = 0, kctu
+!AH             DO kk = 0, kcto+1
+             DO kk = 0, cg%nz+1
 !
 !--             u-component
@@ -3223,5 +3411,6 @@
              ENDDO
 
-             DO kk = 0, kctw
+!AH             DO kk = 0, kctw+1
+             DO kk = 0, cg%nz+1
 !
 !--             w-component 
@@ -3259,5 +3448,4 @@
              ENDIF
           ENDDO
-
 
           DO  jj = jcs, jcn
@@ -3275,6 +3463,6 @@
        ENDIF
       
-       ALLOCATE( fraz(0:kctu) )
-       DO  kk = 0, kctu
+       ALLOCATE( fraz(0:kcto) )
+       DO  kk = 0, kcto
           zeta = ( ( zu(nzt) - cg%zu(kk) ) / anterp_relax_length_t )**4
           fraz(kk) = zeta / ( 1.0_wp + zeta )
@@ -3462,5 +3650,5 @@
        coord_x(i) = lower_left_coord_x + i * dx
     ENDDO
-     
+
     DO  j = -nbgp, ny + nbgp
        coord_y(j) = lower_left_coord_y + j * dy
@@ -3472,5 +3660,4 @@
 
 
-
  SUBROUTINE pmci_set_array_pointer( name, child_id, nz_cl, n )
 
@@ -3487,4 +3674,5 @@
 
     REAL(wp), POINTER, DIMENSION(:,:)     ::  p_2d        !<
+    REAL(wp), POINTER, DIMENSION(:,:)     ::  p_2d_sec    !<
     REAL(wp), POINTER, DIMENSION(:,:,:)   ::  p_3d        !<
     REAL(wp), POINTER, DIMENSION(:,:,:)   ::  p_3d_sec    !<
@@ -3584,4 +3772,5 @@
 
 
+
 INTEGER FUNCTION get_number_of_childs ()
 
@@ -3614,4 +3803,5 @@
 
 END FUNCTION get_childid
+
 
 
@@ -3641,4 +3831,6 @@
 END SUBROUTINE get_child_edges
 
+
+
 SUBROUTINE  get_child_gridspacing (m, dx,dy,dz)
 
@@ -3656,5 +3848,7 @@
 END SUBROUTINE get_child_gridspacing
 
-SUBROUTINE pmci_create_child_arrays( name, is, ie, js, je, nzc,n  )
+
+
+SUBROUTINE pmci_create_child_arrays( name, is, ie, js, je, nzc, n  )
 
     IMPLICIT NONE
@@ -3666,5 +3860,5 @@
     INTEGER(iwp), INTENT(IN) ::  je      !<
     INTEGER(iwp), INTENT(IN) ::  js      !<
-    INTEGER(iwp), INTENT(IN) ::  nzc     !<  Note that nzc is cg%nz
+    INTEGER(iwp), INTENT(IN) ::  nzc     !<  nzc is cg%nz, but note that cg%nz is not the original nz of parent, but the highest parent-grid level needed for nesting.
 
     INTEGER(iwp), INTENT(IN), OPTIONAL ::  n  !< number of chemical species
@@ -3819,9 +4013,12 @@
 !--    The interpolation.
        CALL pmci_interp_tril_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,   &
-                                   r2yo, r1zo, r2zo, 'u' )
+                                   r2yo, r1zo, r2zo, kcto, iflu, ifuu,         &
+                                   jflo, jfuo, kflo, kfuo, ijkfc_u, 'u' )
        CALL pmci_interp_tril_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,   &
-                                   r2yv, r1zo, r2zo, 'v' )
+                                   r2yv, r1zo, r2zo, kcto, iflo, ifuo,         &
+                                   jflv, jfuv, kflo, kfuo, ijkfc_v, 'v' )
        CALL pmci_interp_tril_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,   &
-                                   r2yo, r1zw, r2zw, 'w' )
+                                   r2yo, r1zw, r2zw, kctw, iflo, ifuo,         &
+                                   jflo, jfuo, kflw, kfuw, ijkfc_w, 'w' )
 
        IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.          &
@@ -3829,15 +4026,18 @@
                .NOT. constant_diffusion ) )  THEN
           CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, &
-                                      r2yo, r1zo, r2zo, 'e' )
+                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,       &
+                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 'e' )
        ENDIF
 
        IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
           CALL pmci_interp_tril_all ( diss,  dissc,  ico, jco, kco, r1xo, r2xo,&
-                                      r1yo, r2yo, r1zo, r2zo, 's' )
+                                      r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,&
+                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
        ENDIF
 
        IF ( .NOT. neutral )  THEN
           CALL pmci_interp_tril_all ( pt, ptc, ico, jco, kco, r1xo, r2xo,      &
-                                      r1yo, r2yo, r1zo, r2zo, 's' )
+                                      r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,&
+                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
        ENDIF
 
@@ -3845,18 +4045,27 @@
 
           CALL pmci_interp_tril_all ( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo, &
-                                      r2yo, r1zo, r2zo, 's' )
+                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
+                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
 
           IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
              CALL pmci_interp_tril_all ( qc, qcc, ico, jco, kco, r1xo, r2xo,   &
-                                          r1yo, r2yo, r1zo, r2zo, 's' ) 
+                                         r1yo, r2yo, r1zo, r2zo, kcto,         &
+                                         iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
+                                         ijkfc_s, 's' ) 
              CALL pmci_interp_tril_all ( nc, ncc, ico, jco, kco, r1xo, r2xo,   &
-                                         r1yo, r2yo, r1zo, r2zo, 's' )   
+                                         r1yo, r2yo, r1zo, r2zo, kcto,         &
+                                         iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
+                                         ijkfc_s, 's' )   
           ENDIF
 
           IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
              CALL pmci_interp_tril_all ( qr, qrc, ico, jco, kco, r1xo, r2xo,   &
-                                         r1yo, r2yo, r1zo, r2zo, 's' )
+                                         r1yo, r2yo, r1zo, r2zo, kcto,         &
+                                         iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
+                                         ijkfc_s, 's' )
              CALL pmci_interp_tril_all ( nr, nrc, ico, jco, kco, r1xo, r2xo,   &
-                                         r1yo, r2yo, r1zo, r2zo, 's' )
+                                         r1yo, r2yo, r1zo, r2zo, kcto,         &
+                                         iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
+                                         ijkfc_s, 's' )
           ENDIF
 
@@ -3865,5 +4074,6 @@
        IF ( passive_scalar )  THEN
           CALL pmci_interp_tril_all ( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,  &
-                                      r2yo, r1zo, r2zo, 's' )
+                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
+                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
        ENDIF
 
@@ -3873,5 +4083,6 @@
                                          chem_spec_c(:,:,:,n),                 &
                                          ico, jco, kco, r1xo, r2xo, r1yo,      &
-                                         r2yo, r1zo, r2zo, 's' )
+                                         r2yo, r1zo, r2zo, kcto, iflo, ifuo,   &
+                                         jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
           ENDDO
        ENDIF
@@ -3912,5 +4123,6 @@
 
     SUBROUTINE pmci_interp_tril_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,    &
-                                     r1z, r2z, var )
+                                     r1z, r2z, kct, ifl, ifu, jfl, jfu,        &
+                                     kfl, kfu, ijkfc, var )
 !
 !--    Interpolation of the internal values for the child-domain initialization
@@ -3925,7 +4137,26 @@
        INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !<
 
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !<
+       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc       !<
+       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r1x   !<
+       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r2x   !<
+       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r1y   !<
+       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r2y   !<
+       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r1z   !<
+       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r2z   !<
+
+       INTEGER(iwp) :: kct
+       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+       INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+
        INTEGER(iwp) ::  i        !<
        INTEGER(iwp) ::  ib       !<
        INTEGER(iwp) ::  ie       !<
+       INTEGER(iwp) ::  ijk      !<
        INTEGER(iwp) ::  j        !<
        INTEGER(iwp) ::  jb       !<
@@ -3939,14 +4170,8 @@
        INTEGER(iwp) ::  m        !<
        INTEGER(iwp) ::  n        !<
-
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !<
-       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc       !<
-       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r1x   !<
-       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r2x   !<
-       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r1y   !<
-       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r2y   !<
-       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r1z   !<
-       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r2z   !<
-
+       INTEGER(iwp) ::  var_flag !<
+
+       REAL(wp) ::  cellsum    !<
+       REAL(wp) ::  cellsumd   !<
        REAL(wp) ::  fk         !<
        REAL(wp) ::  fkj        !<
@@ -3957,4 +4182,6 @@
        REAL(wp) ::  logratio   !<
        REAL(wp) ::  logzuc1    !<
+       REAL(wp) ::  rcorr      !<
+       REAL(wp) ::  rcorr_ijk  !<       
        REAL(wp) ::  zuc1       !<
        REAL(wp) ::  z0_topo    !<  roughness at vertical walls
